#include "main.h" 

using namespace std;

int main()
{
	Sedan sedan("sedan test", 123);
	sedan.printInfo();

	Sportcar sportcar("sportcar test", 2443);
	sportcar.printInfo();

	Car car(433, sedan, sportcar);
	car.printInfo();
	return 0;
}

Sedan::Sedan()
{
	str = new char [256];
	str[0] = '\0';

	value = 0;
}

Sedan::Sedan(const char *input_str, const int input_value)
{
	str = new char [strlen(input_str) + 1];
	strcpy(str, input_str);

	value = input_value;
}

Sedan::Sedan(const Sedan &obj)
{
	str = new char [strlen(obj.str) + 1];
	strcpy(str, obj.str);

	value = obj.value;
}

Sedan::~Sedan()
{
	if (str) {
		delete str;
	}
}

void Sedan::printInfo()
{
	cout << "Sedan:" << endl;
	cout << "\t" << str << "\n\t" << value << endl;
}

Sportcar::Sportcar()
{
	str = new char [256];
	str[0] = '\0';

	value = 0;
}

Sportcar::Sportcar(const char *input_str, const int input_value)
{
	str = new char [strlen(input_str) + 1];
	strcpy(str, input_str);

	value = input_value;
}

Sportcar::Sportcar(const Sportcar &obj)
{
	str = new char [strlen(obj.str) + 1];
	strcpy(str, obj.str);

	value = obj.value;
}

Sportcar::~Sportcar()
{
	if (str) {
		delete str;
	}
}

void Sportcar::printInfo()
{
	cout << "Sportcar:" << endl;
	cout << "\t" << str << "\n\t" << value << endl;
}

Car::Car()
{
	value = 0;
	sedanObj = NULL;
	sportcarObj = NULL;
}

Car::Car(const int input_value, Sedan &input_sedan, Sportcar &input_sportcar)
{
	value = input_value;
	sedanObj = new Sedan(input_sedan);
	sportcarObj = new Sportcar(input_sportcar);
}

Car::~Car()
{
	if (sedanObj) {
		delete sedanObj;
	}
	if (sportcarObj) {
		delete sportcarObj;
	}
}

void Car::printInfo()
{
	cout << "----" << endl;
	cout << "Car:" << endl;
	cout << "\t" << value << endl;

	sedanObj->printInfo();
	sportcarObj->printInfo();
}